*** Alex, while I am writing this, I realise it may be better to do this all in a script. Could you have a look 
*** and see what you think? If so, could you please translate it to a script? Is it possible to make a paste button that
*** makes a syntax file with user defined fields?

** SCHID = Unique school ID.
** STRAT = Explicit sampling stratum.
** ORDER = Variable that orders schools according to the sampling frame.
** ZONE = Jackknife zone.
** IND = Jackknife indicator (0,1) [check in script].
** FWGT = Full student weight.


define !mcr (infile=!charend('/')
            /schid=!charend('/')
            /strat=!charend('/')
            /order=!charend('/')
            /zone=!charend('/')
            /ind=!charend('/')
            /fwgt=!charend('/')).

dataset close all.
get file=!quote(!infile).
sort cases by !STRAT !ORDER !ZONE .
do if ($casenum=1).
compute @ZONE=1.
else if (!ZONE=lag(!ZONE)).
compute @ZONE=LAG(@ZONE).
else if (!ZONE<>lag(!ZONE)).
compute @ZONE=LAG(@ZONE)+1.
end if.
compute CONS=1.
aggregate outfile=* mode=addvariables /break=CONS /@NZONES=max(@ZONE).
formats @ZONE @NZONES (f5.0).

compute @IND=!IND.
compute @FWGT=!FWGT.
temp.
select if ($casenum=1).

write outfile='c:\temp\mcr_CreateRWGT.sps' 
/"vector RWGT(" @NZONES ")."
/"loop #i = 1 to " @NZONES"."
/"do if (@ZONE=#i)."
/"compute RWGT(#i)=2*@IND*@FWGT."
/"else."
/"compute RWGT(#i)=@FWGT."
/"end if."
/"end loop.".
exe.

insert file='c:\temp\mcr_CreateRWGT.sps'.
exe.
delete vars CONS @ZONE @NZONES @IND @FWGT.

!enddefine.

***********************************************************************.

set mprint=no.
!mcr infile=c:\temp\data.sav
       /schid=SCHID 
       /strat=STRAT 
       /order=ORDER 
       /zone=ZONE
       /ind=IND 
       /fwgt=FWGT.
